<template>
  <div style="margin: 3rem">
    <el-header style="margin-top:10rem">
      <ReturnButton  :offsetArrow="17" :spanTitle="4" title="Materiales de Televisa" v-on:clickEvent="returnPage" style="margin:0 0 2rem 12rem"></ReturnButton>
      <!-- buscador -->
      <el-col style="display: flex; justify-content: flex-end !important">
        <!-- @handleSelect="handleSelect"  -->
        <autocomplete 
          @handleSelect="handleSelect"
          @querySearch="querySearch" 
          :text="textSearch"
          placeholderText="Buscar Material"
          colorOrange='true'
          ></autocomplete>
      </el-col>
      <!-- titulo -->
      <el-col :offset="2" :span="20" class="bg-dark-gray " style="padding:10px 20px">
        <h3 class="text-white">{{materialName}}</h3>
      </el-col>
    </el-header>
    <el-main style="margin: 10rem 8%">
      <el-row style="margin:0 1rem">
        <el-col class="margin-Title"><span class="text-bold">Tipo de Material:</span><span style="margin:0 0.8rem"> {{typeOfContent}}</span></el-col>
        <el-col class="margin-Title">
          <span class="text-bold">Proveedor:</span><span style="margin:0 0.8rem"> {{providerName}}</span>
        </el-col>
        <el-col class="margin-Title">
          <span class="text-bold" style="margin-right:0.8rem">Productora:</span>
          <span v-if="reviewObj">
            <span v-for="(prod, h) in reviewObj.arrProdCompany" :key="h">
              <span v-if="h === reviewObj.arrProdCompany.length-1">{{prod.prodCompany}}</span>
              <span v-else style="margin-right:1rem">{{prod.prodCompany}}</span>
            </span>
          </span>
        </el-col>
        <!-- FILTRO PARA SELECCIONAR LA TEMPORADA -->
        <el-col v-if="numChapters.length > 0" style="margin-top:2rem">
          <el-select v-model="filterSelect" placeholder="Temporada" size="small" clearable @change="selectSeas">
            <el-option
              v-for="aSeason in allSeasons"
              :key="aSeason.value"
              :label="aSeason.label"
              :value="aSeason.value">
            </el-option>
          </el-select>
        </el-col>
      </el-row>
      <!-- Recepción -->
      <h4 style="margin: 3rem 1rem 1rem" class="text-orange">RECEPCIÓN DEL MATERIAL</h4>
      <div style="margin:2rem 1rem">
        <el-table
          :data="tableReception"
          :header-cell-class-name="headerCellClassName"   
          border max-height="500" min-height="100"
          style="width: 100%">
          <el-table-column v-if="numChapters.length > 0"
            prop="chapter" label="CAPÍTULO" width="150">
          </el-table-column>
          <el-table-column prop="arrivalDate" label="FECHA DE LLEGADA" width="182"></el-table-column>
          <el-table-column prop="shippingMode" label="MODO DE ENVÍO" width="180"></el-table-column>
          <el-table-column prop="support" label="SOPORTE DE LLEGADA" min-width="220"></el-table-column>
          <el-table-column
            label="REPOSICIÓN"
            width="200">
            <template slot-scope="table">
              <div v-if="indexReposition.includes(table.$index)">
                <el-button            
                  size="mini"
                  type="success" 
                  plain
                  @click="showTableRepo(table.$index, table.row)"
                  >DETALLES
                </el-button>
              </div>
              <div v-else></div>
            </template>
          </el-table-column>
        </el-table>
        <el-dialog :visible.sync="dialogTableVisible" width="50%">
          <div style="margin:1rem 0 2rem"  >
            <h3 class="bolt-light"> <span class="text-red"> REPOSICIÓN -  </span> {{ materialName }}  </h3> 
          </div>
          <el-table :data="receptionData" border :header-cell-class-name="headerCellClassName">
            <el-table-column
              v-if="numChapters.length > 0"
              property="chapter" label="CAPÍTULO" fixed width="100">
            </el-table-column>
            <el-table-column property="stateRepo" label="ESTADO" width="120"></el-table-column>
            <el-table-column property="arrivalDate" label="FECHA DE LLEGADA" width="200"></el-table-column>
            <el-table-column property="shippingMode" label="MODO DE ENVÍO" width="200"></el-table-column>
            <el-table-column property="support" label="SOPORTE" width="120"></el-table-column>
          </el-table>
        </el-dialog>
      </div>
      <!-- Almacenamiento -->
      <h4 style="margin: 4rem 1rem 1rem" class="text-orange">ALMACENAMIENTO DEL MATERIAL</h4>
      <div style="margin:2rem 1rem">
        <el-table
          :data="tableStorage"
          :header-cell-class-name="headerCellClassName"
          border
          max-height="500" min-height="100"
          style="width: 100%">
          <el-table-column v-if="numChapters.length > 0"
            prop="chapter" label="CAPÍTULO" fixed width="100">
          </el-table-column>
          <el-table-column prop="codeDisk" label="CÓDIGO DE DISCO" width="180">
            <template slot-scope="scope">
              <div style="margin-left: 10px"
                v-for="(val, index) in scope.row.codeDisk"
                :key="index">
                <p> {{ val || 'No ingresado'}}</p>
              </div>
            </template>
          </el-table-column>
          <el-table-column prop="typeStorage" label="SOPORTE DE ALMACÉN" width="200">
            <template slot-scope="scope">
                <div style="margin-left: 10px"
                  v-for="(val, index) in scope.row.typeStorage"
                  :key="index">
                  <p> {{ val || 'No ingresado'}}</p>
                </div>
              </template> 
          </el-table-column>
          <el-table-column prop="dateOfCopy" label="FECHA DE COPIADO" width="180"></el-table-column>
          <el-table-column prop="storages" label="ALMACENAMIENTO" width="180">
            <template slot-scope="scope">
              <div>
                {{scope.row.storages || 'No ingresado'}}
              </div>
            </template>
          </el-table-column>
          <el-table-column prop="videoteca" label="VIDEOTECA" width="150"></el-table-column>
          <el-table-column prop="copyBackup" label="BACKUP" width="100">
            <template slot-scope="scope">
              <div>
                {{returnBackUpText(scope.row.copyBackup)}}
              </div>
            </template>
          </el-table-column>
          <el-table-column label="REPOSICIÓN" width="170">
            <template slot-scope="tstorage"> 
              <div v-if="indexReposition.includes(tstorage.$index)">
                <el-button            
                  size="mini"
                  type="success" 
                  plain
                  @click="showTableStora(tstorage.$index, tstorage.row)"
                  >DETALLES
                </el-button>
              </div>
              <div v-else></div>
            </template>
          </el-table-column>
        </el-table>
        <el-dialog :visible.sync="dialogStorage"  width="70%">
          <div style="margin:1rem 0 2rem"  >
            <h3 class="bolt-light"> <span class="text-red"> REPOSICIÓN -  </span> {{ materialName }}  </h3> 
          </div>
          <el-table :data="storageData" border  :header-cell-class-name="headerCellClassName" >
            <el-table-column v-if="numChapters.length > 0"
              property="chapter" label="CAPÍTULO" fixed width="100">
            </el-table-column>
            <el-table-column property="stateRepo" label="ESTADO" width="120"></el-table-column>
            <el-table-column property="codeDisk" label="CÓDIGO DE DISCO" width="200">
              <template slot-scope="scope">
                <div style="margin-left: 10px"
                  v-for="(val, index) in scope.row.codeDisk"
                  :key="index">
                  <p> {{ val || 'No ingresado'}}</p>
                </div>
              </template>
            </el-table-column>
            <el-table-column property="typeStorage" label="SOPORTE DE ALMACÉN" width="120">
              <template slot-scope="scope">
                <div>
                  {{scope.row.typeStorage || 'No ingresado'}}
                </div>
              </template>
            </el-table-column>
            <el-table-column property="dateOfCopy" label="FECHA DE COPIADO" width="170"></el-table-column>
            <el-table-column property="storages" label="ALMACENAMIENTO" width="170">
              <template slot-scope="scope">
                <div>
                  {{scope.row.storages || 'No ingresado'}}
                </div>
              </template>
            </el-table-column>
            <el-table-column property="videoteca" label="VIDEOTECA" width="150"></el-table-column>
            <el-table-column property="copyBackup" label="BACKUP" width="100">
              <template slot-scope="scope">
                <div>
                  {{returnBackUpText(scope.row.copyBackup)}}
                </div>
              </template>
            </el-table-column>
          </el-table>
        </el-dialog>
      </div>
    </el-main>
  </div>
</template>
<style>
 .margin-Title {
   margin: 0.5rem 0
 }

</style>
<script>

import ReturnButton from '@/components/ReturnButton.vue'
import SearchFilter from '@/components/searchFilter.vue'
import autocomplete from '@/components/autocomplete.vue'
import { convertDate } from '../../../../utils/calculateTime.js'
import { modifyText } from '../../../../utils/modifyText.js'
import { HTTP } from '../../../../main.js'

export default {
  components: {
    ReturnButton,
    autocomplete,
    'app-search-filter': SearchFilter,
  },
  data () {
    return {
      // chapters: false,
      dialogTableVisible: false, // modal recepción reposición
      dialogStorage: false, // modal de almacenamiento reposición
      filterSelect: '', // select
      materialName: '',
      materials: JSON.parse(this.$localStorage.get('televisaHistorial')), // trae materiales de vista HistorialTelevisa
      typeOfContent: '',
      reviewObj: {}, // se obtiene productora
      receptionData: [], // tabla de reposición de recepción
      indexReposition: [],
      seleSeason: '',
      storageMat: [], // datos de almacenamiento de colección materiales
      storageData: [], // tabla de reposicion de almacenamiento
      textSearch: '',
      tableReception: [], // tabla de recepcion
      tableStorage: [], // tabla de almacenamiento,
      links: '',
      idMaterial: '',
      typeMaterialSelected: localStorage.getItem('typeMaterialSelected'),
      idRecordCan: localStorage.getItem('idRecordCanned'),
      elementSelectTelevisa: JSON.parse(this.$localStorage.get('elementSelectTelevisa')),
      infoSupport: [],
      numChapters: [],
    }
  },
  computed: {
    title() {
      let title = 'REPOSICIÓN - ' + this.materialName
      return title
    },
    allSeasons(){
      let arrSeason = []
      this.numChapters.map((el) => {
        arrSeason.push({value: el.season, label:'Temporada ' + el.season})
      })
      return arrSeason
    },
    // materialData(){
    //   let exitInfoSupport = this.elementSelectTelevisa.infoSupport? [this.elementSelectTelevisa.infoSupport[0]] : null
    //   return this.elementSelectTelevisa.numChapters && this.elementSelectTelevisa.numChapters.length > 0 ? this.elementSelectTelevisa.numChapters[0].infoByChapter : exitInfoSupport
    // }
  },
  created () {
    let idRecordCan = this.$localStorage.get('idRecordCanned')
    this.getAllMaterialsToShow()
    this.getLocal()
    // this.setData(idRecordCan)
  },
  methods: {
    getAllMaterialsToShow() {
      if(this.typeMaterialSelected == 'Especial'){
        this.getMaterialAffiliate('TELEVISA - ESPECIALES')
      } else if(this.typeMaterialSelected == 'Novelas'){
        this.getMaterialAffiliate('TELEVISA - TELENOVELAS')
      } else if(this.typeMaterialSelected == 'Series'){
        this.getMaterialAffiliate('TELEVISA - SERIES')
      }
      this.getMaterials()
    },
    getMaterialAffiliate(material){
      HTTP.get('materials/materialType/'+material)
      .then(res => {
        this.televisaMat = res.data.materials
      })
      .catch(err => {
        console.log(err);
      });
    },
    getMaterials () {
      HTTP.get('materials/materialType/Televisa/typeOfContent/' + this.typeMaterialSelected + '/providerName')
      .then(res => {
        let data = res.data.materials
        this.links = data.filter(e => e.stringMaterialType == "Afiliación-Televisa")
      })
      .catch(err => {
        console.log(err);
      });
    },
    selectSeas (value) {
      this.tableReception = []
      this.tableStorage = []
      this.initTable(value)
    },
    headerCellClassName ({row, column, rowIndex, columnIndex}) {
      
      if(rowIndex === 0 && column.label=== 'REPOSICIÓN' || column.label=== 'ESTADO'){
        return 'text-red bg-light-red'
      }
      if (rowIndex === 0) {
        return 'bg-light-red';
      } 
    },
    showTableStora (index, row){
      //boton de detalles de almacenamiento
      this.storageData = []
      this.dialogStorage = true
      
      if (this.numChapters.length > 0) {
        this.numChapters.map((el) => {
          if (el.season === this.filterSelect) {
            el.infoByChapter.map((chap, i)=>{
              if (i === index) {
              // console.log(chap) // ingresar al array reposicion
                chap.reposicion.map((rep) => {
                  this.fillTableStorage(rep, this.storageData, index)
                })
              }
            })
          }
        })
      }else{ // SIN CAPS
        // this.storageData = []
        let repoArray = this.infoSupport[0].reposicion
        if (repoArray.length > 0) {
          repoArray.map((elrepo) => {
            this.fillTableStorage(elrepo, this.storageData)
          })
        }
      }
    },
    showTableRepo (index, row){
      // // boton detalles de reposición de recepción
      this.receptionData = []
      this.dialogTableVisible = true
      
      if (this.numChapters.length > 0) {
         this.numChapters.map((el) => {
          if (el.season === this.filterSelect){
            el.infoByChapter.map((chap, i) => {
              if (i === index){
                // console.log(chap)
                chap.reposicion.map((rep) => {
                  // console.log(rep)
                  this.fillTableReception(rep, this.receptionData, index)
                })
              }
            })
          }
        })  
      }else{
        // this.receptionData = []
        let repoArray = this.infoSupport[0].reposicion
        if (repoArray.length > 0) {
          repoArray.map((elrepo) => {
            this.fillTableReception(elrepo, this.receptionData)
          })
        }
      }
    },
    getLocal (){ //información que se trae de la vista anterior
      let idRecordCan = this.$localStorage.get('idRecordCanned')
      this.materials.map((elem) => {
        this.getItemOfMaterials( elem, elem.__id, idRecordCan)
      })
      this.initTable() //tablas
    },
    getItemOfMaterials (elemento, item1, item2){ //para series y capítulos
      // traer materiales
      if(item1 === item2){
        this.materialName = elemento.listTitle
        this.typeOfContent = elemento.typeOfContent
        this.providerName = elemento.providerName
        this.infoSupport = elemento.infoSupport
        this.numChapters = elemento.numChapters

        if(elemento.reviewObj){
          this.reviewObj = elemento.reviewObj
        }

        if(this.numChapters.length > 0){ 
          this.initTable('1')
          this.filterSelect = '1'
        }
      }
    }, 
    fillTableReception (chap, table, indexChapter){
      let date = this.convertDateValid(chap.arrivalDate)
      let newObject = {
                        chapter: (indexChapter !== undefined)?indexChapter+1:chap.chapter,
                        arrivalDate: date,
                        shippingMode: chap.shippingMode || 'No ingresado',
                        support: chap.support || 'No ingresado',
                        stateRepo:'Reposición'
                      }
      table.push(newObject)
    },
    fillTableStorage (chap, table, indexChapter){
      let dateOfCopy = (this.numChapters.length >0)?chap.dateCopy:chap.dateOfCopy
      let date = this.convertDateValid(dateOfCopy) // fecha de copiado
      let arrCodeDisk = [], arrTypeStorage= []
      let supportMaterial = (this.numChapters.length >0)?chap.typeStorage:chap.supportMaterial
      if(supportMaterial) {
        supportMaterial.map((el) => { //obteniendo datos de codigo de disco y soporte de Almacén
          // console.log(el.typeStorage, 'el.typeStorage')
          const {codeDisk, typeStorage} = el
          let conditionalCodeDisk = codeDisk ? codeDisk + '\n' : 'No ingresado'
          let conditionalTypeStorage = typeStorage ? typeStorage + '\n' : 'No ingresado'
          arrCodeDisk.push(conditionalCodeDisk)
          arrTypeStorage.push(conditionalTypeStorage)
        })
      }
      
      let copyBackup = (this.numChapters.length >0)?chap.copyBackUpStorage:chap.copyBackup
      let storages =  (this.numChapters.length >0)?chap.storage:chap.storages

      let newObject = {
                        chapter: (indexChapter !== undefined)?indexChapter+1:chap.chapter,
                        dateOfCopy: date,
                        storages: storages,
                        copyBackup: copyBackup,
                        videoteca: chap.videoteca || 'No ingresado',
                        codeDisk: arrCodeDisk,
                        typeStorage: arrTypeStorage,
                        stateRepo:'Reposición',
      }
      table.push(newObject)

    },
    initTable (value){
      if (this.numChapters.length > 0) {
        this.numChapters.map((season) =>{
          if (season.season === value){
            (season.infoByChapter).map((chapter, indexChap)=>{
              let validateIfExist = chapter.support !== undefined && chapter.arrivalDate !== undefined && chapter.shippingMode !== undefined
              if(validateIfExist){
                if (chapter.reposicion !== undefined && chapter.reposicion.length > 0){             
                  this.indexReposition.push(indexChap)
                }
                this.fillTableReception(chapter, this.tableReception)
                this.fillTableStorage(chapter, this.tableStorage)
              }
            })
          }
        })
      } else{
        if(this.infoSupport.length > 0){
          this.fillTableReception(this.infoSupport[0], this.tableReception)
          this.fillTableStorage(this.infoSupport[0], this.tableStorage)
          if(this.infoSupport[0].reposicion.length > 0){
            this.indexReposition.push(0)
          }
        }
      }

    },
    searchEvent (){
      this.tableReception = []
      this.tableStorage = []
      this.materials.map((elem)=>{
        // console.log(elem)
        this.getItemOfMaterials(elem, elem.originalTitle, this.textSearch)
      })
      this.initTable() // tablas
    },
    returnPage () {
      this.$router.push({ name: 'historialTelevisa' })
    },
    handleSelect(item) {
      /*Limpiando la data de las tablas */
      this.indexReposition = []
      this.tableReception = []
      this.tableStorage = []
      /* --- */
      let valueMat = item
      this.textSearch = valueMat.originalTitle
      this.idMaterial = valueMat.__id 
      this.$localStorage.set('televisaHistorial', this.idMaterial)
      let idRecordCan = this.$localStorage.get('televisaHistorial')
      if(this.televisaMat == undefined){
        this.televisaMat = []
      }
      let materialSelectToShow = this.links.concat(this.televisaMat)
      materialSelectToShow.map((elem)=>{ // traer materiales que coinciden con el id
        this.getItemOfMaterials( elem, elem.__id, idRecordCan)
      })
      this.initTable() //tablas  
    },
    querySearch(queryString, cb) {
      if(this.televisaMat == undefined){
        this.televisaMat = []
      }
      var links = this.links.concat(this.televisaMat);
      var results = queryString ? links.filter(this.createFilter(queryString)) : links
      cb(results)
    },
    createFilter (queryString) {
      return (link) => {
        return (link.originalTitle.toLowerCase().indexOf(queryString.toLowerCase()) !== -1)
      }
    },
    convertDateValid(value) {
      if(!value || value === '') {
        return 'No ingresado'
      } else {
        return convertDate(value)
      }
    },
    returnBackUpText(val) {
      let response
      switch(val) {
        case 'NO':
          response = 'No'
        break;
        case 'SÍ': 
          response = 'Si'
        break;
        default:
          response = 'No copiado'
        break;
      }
      return response
    }
  }
}
</script>

